/*
 * Copyright (c) 2014 Atmark Techno, Inc.
 */

#include "board.h"
#include "mmcsd.h"
#include "types.h"
#include "delay.h"
#include "sdhi.h"
#include "da9063.h"
#include "gpio.h"

#define SD0_PWR_EN	PIN(6, 24)
#define SD1_PWR_EN	PIN(6, 26)

void sdhi_voltage_init(void)
{
	u8 buf;

	buf = 0;
	da9063_write(0x28, 1, &buf);
	da9063_write(0x29, 1, &buf);

	mdelay(1);

	gpio_direction_output(SD0_PWR_EN, 0);
	gpio_direction_output(SD1_PWR_EN, 0);

	mdelay(300);

	gpio_direction_output(SD0_PWR_EN, 1);
	gpio_direction_output(SD1_PWR_EN, 1);

	mdelay(5);

	buf = 0;
	da9063_write(0x32, 1, &buf);
	da9063_write(0x33, 1, &buf);

	buf = 1;
	da9063_write(0x28, 1, &buf);
	da9063_write(0x29, 1, &buf);

	udelay(300);
}

#define ALARM_LED	PIN(2, 4)
void alarm_led_off(void)
{
	gpio_direction_output(ALARM_LED, 0);
}
