/*
 * Copyright (c) 2014 Atmark Techno, Inc.
 */

#include "board.h"
#include "qspi.h"
#include "io.h"
#include "mmcsd.h"
#include "types.h"
#include "delay.h"
#include "sdhi.h"
#include "scif.h"

typedef void (*bootloader_t)(void);

static void halt(void)
{
	while (1);
}

void ipl_main(void)
{
	bootloader_t hermit = (bootloader_t)SRAM_HERMIT_START;
	int port;
	int ret;

	alarm_led_off();

	scif_setup();
	tpu_setup();

	if (sw_sdboot_en()) {
		sdhi_voltage_init();

		if (sw_sdhi0_en())
			port = 0;
		else
			port = 1;

		sdhi_setup(port);
		ret = mmcsd_load_hermit(port);
		if (ret)
			halt();
	} else {
		qspi_setup();
		qspi_read_fast(QSPI_HERMIT_START, (u8 *)SRAM_HERMIT_START,
			       QSPI_HERMIT_SIZE);
	}

	hermit();
}
