#ifndef _IPL_QSPI_H_
#define _IPL_QSPI_H_

#include "types.h"

/* SPI Flash Commands */
#define CMD_READ_ID		0x9f
#define CMD_READ		0x03
#define CMD_FAST_READ		0x0b
#define CMD_WRITE_STATUS	0x01
#define CMD_WRITE_DISABLE	0x04
#define CMD_WRITE_ENABLE	0x06
#define CMD_READ_STATUS		0x05
#define CMD_ERASE_CHIP		0xc7
#define CMD_ERASE_4K		0x20
#define CMD_ERASE_64K		0xd8

/* dummy byte */
#define DUMMY			0x00

/* SPI transfer flags */
enum qspi_xfer_state {
	QSPI_XFER_BEGIN = 0,
	QSPI_XFER_END,
};

struct qspi_id {
	unsigned char manufacture;
	unsigned char device;
};

void qspi_setup(void);
void qspi_cleanup(void);

void qspi_read_fast(u32 addr, u8 *buf, u32 len);

#endif
